;;;BEMKOO.LSP BEMasse KOOrdinate
;;;8/12/99 Matthias Koksch
;;;Copyright (C) kubit
;;;BESCHREIBUNG
;;;Dieser Befehl ermglicht das Einfgen von Koordinatenkooten.
;;;Dies wird in Form eines Blocks mit Attributen fr jeden
;;;Koordinatenwert realisiert
;;;****************************************************************
;;;------------------------- GLOBAL INFO --------------------------
;;;Variablen die durch Aufrufe von BEMKOO.LSP angelegt werden:
;;;----------------------------------------------------------------
;;;----------------------------------------------------------------

(defun C:BEMKOO ( / ret pliste
		    cmdsave attsave dimsave ossave)
  ;;;Systemvariablen setzen und sichern
  (setq cmdsave (getvar "CMDECHO")
	attsave (getvar "ATTDIA")
	dimsave (getvar "DIMZIN")
	ossave (getvar "OSMODE")
  )	
  (setvar "CMDECHO" 0)
  (setvar "ATTDIA" 0)
  (setvar "DIMZIN" 0)
  ;;;berprfen ob Block existiert
  (if (tcad_blocktest tcad:cfg:bemkoo-blname)
    (progn
      ;;;TCAD_MSG_34a "\nFehler: Block "
      ;;;TCAD_MSG_34b " nicht vorhanden!"
      (princ (strcat TCAD_MSG_34a tcad:cfg:bemkoo-blname TCAD_MSG_34b))
      (quit)
    )
  )    
  ;;;Dialog aufrufen
  (if (setq ret (tcad:bemkoo:initdialog))
    (progn
      (setq pliste (car ret))		; alle einzelnen Punkte
      (foreach punkt (cadr ret)		; alle Punktobjekte
	(setq punkt (cdr (assoc 10 (entget punkt))))
	(setq punkt (trans punkt 0 1))
	(setq pliste (append pliste (list punkt)))
      )
      ;;;Bemaungen erzeugen
      (foreach punkt pliste (tcad:bemkoo:blein punkt))
    )
  )  
  ;;;Systemvariablen wieder herstellen
  (setvar "CMDECHO" cmdsave)
  (setvar "ATTDIA" attsave)
  (setvar "DIMZIN" dimsave)
  (setvar "OSMODE" ossave)
  (princ)
)

;;;Funktion zum Einfgen des Blockes
(defun tcad:bemkoo:blein ( punkt / pstring x y z befehl)
  ;;;Ofang aus
  (setvar "OSMODE" 0)
  (setq pstring punkt)
  ;;;ggf in das WKS transformieren
  (if (= tcad:bemkoo:wks "1")
    (setq pstring (trans pstring 1 0))
  )
  ;;;Koordinatenwerte berechnen
  (setq x (- (car pstring) (car tcad:bemkoo:basis)))
  (setq y (- (cadr pstring) (cadr tcad:bemkoo:basis)))
  (setq z (- (caddr pstring) (caddr tcad:bemkoo:basis)))
  ;;;Koordinatenwerte als String mit Prfix/Sufix
  (setq x (rtos x))
  (setq y (rtos y))
  (setq z (rtos z))
  ;;;einfgen, mit Test da unter 2000 anderer Befehlsname
  (if (> (atoi (getvar "acadver")) 14)
    (setq befehl "_-INSERT")
    (setq befehl "_INSERT")
  )  
  (command befehl tcad:cfg:bemkoo-blname punkt "" "" "" x y z)
)

;;;Dialog aufrufen
(defun tcad:bemkoo:initdialog ( / dialogloaded userclick dcl_id dcl_hide
		                  flag_wks x_temp y_temp z_temp punkt
			          punktliste ausw objektliste index ename)
  (setq dialogloaded T)
  (setq dcl_hide 2)
  ;;;Savewerte in temporre speichern
  (setq p_temp tcad:bemkoo:basis
        flag_wks tcad:bemkoo:wks
  )	
  ;;;Dialog laden
  (if (= -1 (setq dcl_id (load_dialog "bemkoo")))
    (progn
      ;;;TCAD_MSG_28 "\nFehler: Kann Dialog nicht laden!"
      (princ TCAD_MSG_30)
      (setq dialogloaded nil)
    )  
  )
  (while (> dcl_hide 1)
    (if (and dialogloaded
             (not (new_dialog "bemkoo" dcl_id))
        )
      (progn
        ;;;TCAD_MSG_29 "\nFehler: Kann Dialog nicht anzeigen!"
        (princ TCAD_MSG_31)
        (setq dialogloaded nil)
      )  
    )
    (if dialogloaded
      (progn
        ;;;Initialiserungen
	(setq x_temp (car p_temp)
	      y_temp (cadr p_temp)
	      z_temp (caddr p_temp)
	)       
        (set_tile "tcad_x" (rtos x_temp))
        (set_tile "tcad_y" (rtos y_temp))
        (set_tile "tcad_z" (rtos z_temp))
        (set_tile "tcad_wks" flag_wks)
	(set_tile "tcad_anzahl" (itoa (+ (length punktliste) (length objektliste))))
        ;;;Aktionen
        (action_tile "tcad_bpunkt"  "(done_dialog 2)")
        (action_tile "tcad_x" "(setq x_temp (TCAD_DCL:CHECK_REAL $key $value))")
        (action_tile "tcad_y" "(setq y_temp (TCAD_DCL:CHECK_REAL $key $value))")
        (action_tile "tcad_z" "(setq z_temp (TCAD_DCL:CHECK_REAL $key $value))")
        (action_tile "tcad_wks" "(setq flag_wks $value)")
	(action_tile "tcad_punkt"  "(done_dialog 3)")
	(action_tile "tcad_objekt"  "(done_dialog 4)")
        (action_tile "cancel" "(done_dialog) (setq userclick nil)")  
        (action_tile "accept" "(done_dialog) (setq userclick T)")
        (setq dcl_hide (start_dialog))
	;;;interaktive Nutzerauswahl
        (cond
       	  ;;;Basispunkt picken
 	  ((= dcl_hide 2)
	    (initget 1)
            ;;;TCAD_MSG_32 "\nBezugspunkt whlen: "
            (setq p_temp (getpoint TCAD_MSG_32))
	  )
	  ;;;einzelne Punkte whlen
	  ((= dcl_hide 3)
	    ;;;TCAD_MSG_33 "\nzu bemaende Punkte whlen: "
	    (while (setq punkt (getpoint TCAD_MSG_33))
	      (setq punktliste (append punktliste (list punkt)))
	    )  
	  )
	  ;;;Punktelemente ber Objektwahl
	  ((= dcl_hide 4)
	    (setq ausw (ssget '((0 . "POINT"))))
	    (setq index 0)
	    (if ausw
	      (while (< index (sslength ausw))
	        (setq ename (ssname ausw index))
	        (setq index (1+ index))
	        (setq objektliste (append objektliste (list ename)))
	      )
	    )  
	  )
        )
      )
    )
  )  
  (unload_dialog dcl_id)
  (if userclick
    ;;;Eingaben fr nchsten Aufruf sichern
    (progn
      (setq tcad:bemkoo:basis (list x_temp y_temp z_temp)
            tcad:bemkoo:wks flag_wks
	    userclick (list punktliste objektliste)
      )
    )  
  )    
  userclick
)

;;;TCAD_BLOCKTEST testet ob der in block uebergebene BLOCK
;;;in der Zeichnung existiert, bzw. eine entsprechende DWG
;;;im SuchPfad. Wenn ja wird NIL zurueckgegeben
(defun TCAD_BLOCKTEST (block / blname test)
  (setq blname (tblnext "BLOCK" T))	;erster Block
  (setq test T)		;Block existiert nicht
  (while blname
    (if (= (strcase (cdr (assoc 2 blname))) (strcase block))
      (setq test nil)	;block existiert
    )
    (setq blname (tblnext "BLOCK"))	;naechster Block
  )
  ;;;Jetzt noch der Test ob DWG existiert
  (if test
    (if (findfile (strcat block ".dwg"))
      (setq test nil)
    )  
  )  
  (setq test test)	;test wird zurueckgegeben
)

;;;Initialisierungs- und Savevariablen
(setq tcad:bemkoo:wks "0")	;Vorgabe ob Bezug auf WKS
(setq tcad:bemkoo:basis (list 0 0 0))	;Vorgabe des Bezugspunktes
;;;Messagevariabelen
(setq TCAD_MSG_30 "\nFehler: Kann Dialog nicht laden!"
      TCAD_MSG_31 "\nFehler: Kann Dialog nicht anzeigen!"
      TCAD_MSG_32 "\nBezugspunkt whlen: "
      TCAD_MSG_33 "\nzu bemaende Punkte whlen: "
      TCAD_MSG_34a "\nFehler: Block "
      TCAD_MSG_34b " nicht vorhanden!"
)
;;;der Blockname
(setq tcad:cfg:bemkoo-blname "BEMKOO")


(princ "\nBEMKOO geladen...")
(princ)
